﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Configuration;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using BlogEngine.Core;
using BlogEngine.Core.Providers;
using Page=BlogEngine.Core.Page;

public partial class admin_Pages_BlogMigration : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            DdlProviders.Items.Clear();
            
            BlogProviderSection section = (BlogProviderSection)WebConfigurationManager.GetSection("BlogEngine/blogProvider");
            BlogProviderCollection providers = new BlogProviderCollection();
			ProvidersHelper.InstantiateProviders(section.Providers, providers, typeof(BlogProvider));

            foreach (BlogProvider provider in providers)
            {
                // Don't add the current provider in use, that would be messy. 
                if (provider.Name != section.DefaultProvider)
                    DdlProviders.Items.Add(provider.Name);
            }
        }
    }

    protected void BtnConvert_OnClick(object sender, EventArgs e)
    {
        LblStatus.Text = string.Empty;

        try
        {
            // Get ProviderName to convert to
            string providerName = DdlProviders.SelectedValue;
            BlogProvider convertTo = BlogService.Providers[providerName];

            // Categories
            // Load up Categories
            List<Category> cats = BlogService.Provider.FillCategories();
            foreach (Category cat in cats)
            {
                convertTo.InsertCategory(cat);
            }

            // Posts
            List<Post> posts = BlogService.Provider.FillPosts();
            foreach (Post post in posts)
            {
                convertTo.InsertPost(post);
            }

            // Pages
            List<Page> pages = BlogService.Provider.FillPages();
            foreach (Page page in pages)
            {
                convertTo.InsertPage(page);
            }

            // Update Settings
            StringDictionary settings = BlogService.Provider.LoadSettings();
            convertTo.SaveSettings(settings);

            // Update Ping Services
            StringCollection pingServices = BlogService.Provider.LoadPingServices();
            convertTo.SavePingServices(pingServices);

            // Update display
            BtnConvert.Enabled = false;
            LblStatus.Text = "数据复制完毕！";
        }
        catch(Exception ex )
        {
            LblStatus.Text = "错误：" + ex.Message;
            return;
        }
    }
}
